require 'nexaas/cipher/xor_crypter'

module Nexaas
  module Cipher
    # IDCrypter: XOR cipher as used by Nexaas ID
    class IDCrypter < XorCrypter
      # base64 :reek:BooleanParameter
      # base64 :reek:ControlParameter
      def encrypt(code, base64: true)
        return if code.nil? || code.empty?
        code = Base64.encode64(code).rstrip unless base64
        if salt?
          super(code, base64: true, obfuscate: false, truncate: true)
        else
          code
        end
      end

      # base64 :reek:BooleanParameter
      # base64 :reek:ControlParameter
      def decrypt(code, base64: true)
        res = encrypt(code)
        base64 || res.nil? ? res : Base64.decode64(res)
      end
    end
  end
end
