require 'nexaas/cipher/crypter_base'

module Nexaas
  module Cipher
    # XorCrypter: allows perform XOR cipher
    class XorCrypter < CrypterBase
      protected

      # obfuscate :reek:BooleanParameter
      def do_encrypt(code, obfuscate: false, **options)
        self.class.xor_encrypt(salt.salt(code, **options), code, obfuscate)
      end

      def do_decrypt(code, **options)
        do_encrypt(code, options).split("\0").first
      end

      class << self
        # obfuscate :reek:ControlParameter
        def xor_encrypt(key, code, obfuscate)
          xor(obfuscate ? obfuscate_key(key, code) : code, key)
        end

        def xor(code, key)
          key.unpack('C*').zip(code.unpack('C*')).
            map { |fst, lst| fst ^ (lst || 0) }.
            pack('C*')
        end

        def obfuscate_key(key, code)
          len = key.length
          (code + "\0" + Array(0..255).sample(len).pack('C*'))[0, len]
        end
      end
    end
  end
end
